<?php

namespace backend\controllers;

use Yii;
use app\models\ClienteLineas;
use app\models\ClienteLineasSearch;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;

/**
 * ClienteLineasController implements the CRUD actions for ClienteLineas model.
 */
class ClienteLineasController extends Controller {

    /**
     * @inheritdoc
     */
    public function behaviors() {
        return [
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'delete' => ['POST'],
                ],
            ],
        ];
    }

    /**
     * Lists all ClienteLineas models.
     * @return mixed
     */
    public function actionIndex() {
        $searchModel = new ClienteLineasSearch();
        $dataProvider = $searchModel->search(Yii::$app->request->queryParams);

        return $this->render('index', [
                    'searchModel' => $searchModel,
                    'dataProvider' => $dataProvider,
        ]);
    }

    /**
     * Displays a single ClienteLineas model.
     * @param string $id
     * @return mixed
     */
    public function actionView($id) {
        return $this->render('view', [
                    'model' => $this->findModel($id),
        ]);
    }

    /**
     * Creates a new ClienteLineas model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return mixed
     */
    public function actionCreate() {
        $cliente = new \app\models\Clientes();
        $linea = new \app\models\Linea();
        $clineas = new \app\models\ClienteLineas();
        if ($cliente->load(Yii::$app->request->post()) && $linea->load(Yii::$app->request->post()) && $clineas->load(Yii::$app->request->post()) && \yii\base\Model::validateMultiple([$cliente, $linea])) {
            $cliente->telefono = $linea->numero;
            if (!\Yii::$app->user->can('isAdmin')) {
                $clineas->pdv_id = Yii::$app->user->identity->pdv_id;
            }
//            echo var_dump($cliente);
//            echo var_dump($linea);
//            echo var_dump($clineas);
            if ($cliente->save() && $linea->save()) {
                $clineas->clientes_id = $cliente->id;
                $clineas->linea_id = $linea->id;
                if ($clineas->save()) {
                    \Yii::$app->getSession()->setFlash(
                            'Registro de ventas guardado Correctamente', 'Cliente: ' . $cliente->nombre . ' ' . $cliente->apellidop . ' Folio ICC: ' . $linea->icc
                    );
                    return $this->redirect(['create']);
                }
            }
            //return $this->redirect(['view', 'id' => $cliente->id]);
        } else {
            return $this->render('create', [
                        'cliente' => $cliente,
                        'linea' => $linea,
                        'clineas' => $clineas,
            ]);
        }
    }

    /**
     * Updates an existing ClienteLineas model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param string $id
     * @return mixed
     */
    public function actionUpdate($id) {
        $model = $this->findModel($id);

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->id]);
        } else {
            return $this->render('update', [
                        'model' => $model,
            ]);
        }
    }

    /**
     * Deletes an existing ClienteLineas model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param string $id
     * @return mixed
     */
    public function actionDelete($id) {
        $this->findModel($id)->delete();

        return $this->redirect(['index']);
    }

    /**
     * Finds the ClienteLineas model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param string $id
     * @return ClienteLineas the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id) {
        if (($model = ClienteLineas::findOne($id)) !== null) {
            return $model;
        } else {
            throw new NotFoundHttpException('The requested page does not exist.');
        }
    }

}
